from django.contrib import admin

from .models import Passenger, Booking, Schedule, Sched_Crew, City, Crew_Member, Additional_Item, Flight, Booking_Sched, Booking_AddItem, Pilot, Flight_Attendant

# Register your models here.

class PassengerAdmin(admin.ModelAdmin):
    model = Passenger
    list_display = ('P_ID', 'First_Name', 'Middle_Initial', 'Last_Name', 'Birthdate', 'Age', 'Gender', 'Phone_num', 'Email_add')

class BookingAdmin(admin.ModelAdmin):
    model = Booking
    list_display = ('Booking_ID', 'Booking_Date', 'Passenger', 'Total_Cost')

class Sched_CrewAdmin(admin.ModelAdmin):
    model = Sched_Crew
    list_display = ('Sched_Code', 'Employee_ID')

class ScheduleAdmin(admin.ModelAdmin):
    model = Schedule
    list_display = ('Sched_Code', 'Flight_Date', 'Departure_Time', 'Arrival_Time', 'Duration', 'Flight_Cost', 'Flight_Code')
    def get_readonly_fields(self, request, obj=None):
        if obj:
            return ['Departure_Time', 'Flight_Date', 'Arrival_Time', 'Duration']
        else:
            return []

class CityAdmin(admin.ModelAdmin):
    model = City
    list_display = ('Airport_Code', 'Airport_name', 'City_Name', 'Country')

class Crew_MemberAdmin(admin.ModelAdmin):
    model = Crew_Member
    list_display = ('Employee_ID', 'First_Name', 'Last_Name', 'Role')

class Additional_ItemAdmin(admin.ModelAdmin):
    model = Additional_Item
    list_display = ('Description', 'Item_Cost')

class FlightAdmin(admin.ModelAdmin):
    model = Flight
    list_display = ('Flight_ID', 'Flight_Code', 'Origin_Airport', 'Destination_Airport')

class Booking_SchedAdmin(admin.ModelAdmin):
    model = Booking_Sched
    list_display = ('Booking_ID', 'Sched_Code')

class Booking_AddItemAdmin(admin.ModelAdmin):
    model = Booking_AddItem
    list_display = ('Booking_ID', 'AddItem_Desc', 'Quantity', 'Subtotal')

class PilotAdmin(admin.ModelAdmin):
    model = Pilot
    list_display = ('Employee_ID', 'Rank')

class Flight_AttendantAdmin(admin.ModelAdmin):
    model = Flight_Attendant
    list_display = ('Employee_ID', 'Assigned_Class')


admin.site.register(Passenger, PassengerAdmin)
admin.site.register(Booking, BookingAdmin)
admin.site.register(Sched_Crew, Sched_CrewAdmin)
admin.site.register(Schedule, ScheduleAdmin)
admin.site.register(City, CityAdmin)
admin.site.register(Crew_Member, Crew_MemberAdmin)
admin.site.register(Additional_Item, Additional_ItemAdmin)
admin.site.register(Flight, FlightAdmin)
admin.site.register(Booking_Sched, Booking_SchedAdmin)
admin.site.register(Booking_AddItem, Booking_AddItemAdmin)
admin.site.register(Pilot, PilotAdmin)
admin.site.register(Flight_Attendant, Flight_AttendantAdmin)

