from django.http import HttpResponse
from django.http import Http404
from django.shortcuts import render, redirect
from .models import Booking, Booking_Sched, Passenger, City, Flight, Schedule
from django.views import View
from django.db.models import F

# Create your views here.

def index(request):
    query_dict = request.GET
    query = query_dict.get("q")
    originquery = query_dict.get("originAP")
    destinationquery = query_dict.get("destinationAP")
    
    city = City.objects.order_by('City_Name').all()

    #Initialization
    passenger = Booking.objects.select_related('Passenger').values_list('Booking_ID')        
    originQ = Flight.objects.all()
    destinationQ = Flight.objects.all()
    sched = Schedule.objects.filter(Flight_Code__in=originQ).filter(Flight_Code__in=destinationQ)
    booking = Booking_Sched.objects.select_related('Sched_Code', 'Booking_ID').order_by('-Booking_ID__Booking_Date').all()
    

    #If Origin Query is specifically selected: Activate Origin Filter
    if originquery != "Any":
        originQ = Flight.objects.filter(Origin_Airport=originquery)

    #If Destination Query is specifically selected: Activate Origin Filter
    if destinationquery != "Any":
        destinationQ = Flight.objects.filter(Destination_Airport=destinationquery)
    
    #To Connect city origin and destination to booking
    sched = Schedule.objects.filter(Flight_Code__in=originQ).filter(Flight_Code__in=destinationQ)
        
    #If Search bar is Not empty, null, or 0: Activate Passenger ID Filter
    if query is not None:
        if query != "0":
            if query != "":
                if query != "Passenger ID":
                    #get all Bookings with passenger same as query
                    passenger = Booking.objects.select_related('Passenger').filter(Passenger=query).values_list('Booking_ID')        

    #Search using all filters(If at least query is searched. If not, then the booking won't display without this)
        booking = Booking_Sched.objects.select_related('Sched_Code', 'Booking_ID').filter(Booking_ID__in=passenger, Sched_Code__in=sched).order_by('-Booking_ID__Booking_Date').all()
    context = {
        "booking": booking,
        "city": city
    }
    return render(request, 'booking/index.html', context)

def detail(request, booking_id=None):
    try:
        #for other things
        booking = Booking.objects.get(pk=booking_id)
        #for trip itinerary table
        booksched = Booking_Sched.objects.select_related('Sched_Code').filter(Booking_ID=booking_id).all()
        context = {
            "booking": booking,
            "booksched": booksched
            }
    except Booking.DoesNotExist:
        raise Http404("Booking does not exist!")
    return render(request, "booking/detail.html", context=context)
